#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin>>t;
    for(int k=0; k<t; k++)
    {


    int n;
    cin>>n;
    long long int a[n];
    for(int i=0; i<n; i++)
    {
        cin>>a[i];
    }
    map<long long int, int> mesta;
    long long int unos;
    for(int i=0; i<n; i++)
    {
        cin>>unos;
        if(unos<0)mesta[abs(unos)]=-i;
        else mesta[unos]=i;
    }
    bool ispunjava=true;
    int prvi, drugi, dm;
    for(int i=0; i<n; i++)
    {
        prvi=i;
        drugi=mesta[abs(a[i])];\
        if(drugi<0)
        {
            drugi=-drugi;
            dm=-a[prvi];
        }
        if(a[prvi]/dm<0)
        {
            if(abs(prvi-drugi)%2==0)
            {
                ispunjava=false;
                break;
            }
        }
        else
        {
            if(abs(prvi-drugi)%2!=0)
            {
                ispunjava=false;
                break;
            }
        }
    }
    if(ispunjava)
    {
        cout<<"DA"<<"\n";
    }
    else cout<<"NE"<<"\n";



    }


}